=== debian/changelog ===
trace-cmd (2.9.3-4) unstable; urgency=medium

  * Remove kernelshark
  * Update Standards-Version to 4.6.0.1
  * Add missing libraries. (Closes: #999641)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 04 Dec 2021 19:54:06 +0000

trace-cmd (2.9.3-3) unstable; urgency=medium

  * Upload to unstable.
  * Update Standards-Version to 4.5.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 16 Aug 2021 21:16:54 +0100

trace-cmd (2.9.3-2) experimental; urgency=medium

  * Build binary package for libtracecmd.
  * Fix path for libraries and documentation.
  * Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 06 Jun 2021 23:03:31 +0100

trace-cmd (2.9.3-1) experimental; urgency=medium

  * Update to upstream v2.9.3

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 23 May 2021 15:37:09 +0100

trace-cmd (2.9.2-1) experimental; urgency=medium

  * Update to upstream v2.9.2
  * Fix bash-completion path. (Closes: #984959)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 11 Apr 2021 17:15:55 +0100
