=== debian/control ===
Source: trace-cmd
Section: devel
Priority: optional
Homepage: http://kernelshark.org/
Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Build-Depends: debhelper-compat (= 13), cmake, libjson-c-dev, freeglut3-dev, libxmu-dev, libegl-dev [mipsel], libxi-dev, qtbase5-dev, asciidoc, docbook-xsl, xsltproc, policykit-1, libcunit1-dev, xmlto, pkg-config
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Vcs-Browser: https://github.com/sudipm-mukherjee/trace-cmd.git
Vcs-Git: https://github.com/sudipm-mukherjee/trace-cmd.git

Package: trace-cmd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: kernelshark
Description: Utility for retrieving and analyzing function tracing in the kernel
 This package contains the trace-cmd utility. Trace-cmd makes it easy to
 retrieve and analyze function traces from the Linux kernel while it is running.

Package: libtracecmd0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library for creating and reading trace-cmd data files (shared library)
 The libtracecmd library provides APIs to read trace-cmd data files.
 .
 This package contains the shared library.

Package: libtracecmd-dev
Section: libdevel
Architecture: any
Depends: libtracecmd0 (= ${binary:Version}), ${misc:Depends}
Description: Library for creating and reading trace-cmd data files (development files)
 The libtracecmd library provides APIs to read trace-cmd data files.
 .
 This package is needed to compile programs against libtracecmd0.
