=== debian/tests/control ===
Test-Command: trace-cmd list
Depends: @
Restrictions: needs-root, allow-stderr, superficial
