## trace-cmd 3.0.3

=== debian/changelog ===
trace-cmd (3.0.3-3) unstable; urgency=medium

  * Upload to unstable.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 17 May 2022 09:23:55 +0100

trace-cmd (3.0.3-2) experimental; urgency=medium

  * Add upstream patch to fix build.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 12 May 2022 22:20:36 +0100

trace-cmd (3.0.3-1) experimental; urgency=medium

  * Update to upstream v3.0.3
    - Update doc path.
    - Add symbols.
    - Update soname.
    - Update copyright.
    - Remove patches.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 01 May 2022 01:11:55 +0100
